#include "Main.h"
#include "Control.h"

TIOBuff IOBuff;   // / LIN
unsigned char RX_STEP=0; //    LIN
near BIT F_Low4 = 0;

//------------------------------------------------------
void RXByte( BYTE RX_CHAR){
//------------------------------------------------------
	if (F_NEW_CMD==1) goto rx_bad;   //    
	switch (RX_STEP){
		case (0):{
			if (RX_CHAR==0xF0){
				IOBuff.Head1=RX_CHAR;
				RX_STEP++;
				break;
			}
		}
		case (1):{
			if (RX_CHAR==0x0F){
				IOBuff.Head2=RX_CHAR;
				RX_STEP++;
			}else{
				goto rx_bad;
			}
			break;
		}
		case (2):{						//N Device
			IOBuff.NDev=RX_CHAR;
			IOBuff.CS=RX_CHAR;
			RX_STEP++;
			break;
		}
		case (3):{						//SZ
			IOBuff.CS ^= RX_CHAR;
			IOBuff.Size = RX_CHAR;
			if (IOBuff.Size>66) goto rx_bad;
			RX_STEP++;
			break;
		}
		case (4):{						//CMD
			IOBuff.CS ^= RX_CHAR;
			IOBuff.Cmd = RX_CHAR;
			IOBuff.Count = 0;
			RX_STEP++;
			if (IOBuff.Size==0){
				RX_STEP++;
			}
			break;
		}
		case (5):{						//DATA
			IOBuff.CS ^= RX_CHAR;
			IOBuff.Data[IOBuff.Count] = RX_CHAR;
			IOBuff.Count++;
			if (IOBuff.Count==IOBuff.Size) RX_STEP++;
			break;
		}
		case (6):{						//CS
			if ((IOBuff.CS ^ RX_CHAR) !=0) goto rx_bad;
			IOBuff.Data[IOBuff.Count] = RX_CHAR; // CS    
			IOBuff.Count++;
			RX_STEP++;
			break;
		}
		case (7):{						//0x55
			if (RX_CHAR !=0x55) goto rx_bad;
			IOBuff.Data[IOBuff.Count] = RX_CHAR; // 0x55    
			IOBuff.Count++;
			//  
			RX_STEP=0;
			F_NEW_CMD=1;
			break;
		}
	}//switch
	return;
rx_bad:
	RX_STEP=0;

}

//------------------------------------------------------
void RXData(void){
//------------------------------------------------------
  static BYTE RX_CHAR;
  BYTE  b;
  while (!P_FTRXF){
    P_FTRD=0;
    Nop();
    b=(PORTC & 0x0F);
    P_FTRD=1;
    RX_CHAR=(RX_CHAR<<4)| b;
    if (RX_STEP==0){
      //
      if (RX_CHAR==0xF0){
        RXByte(RX_CHAR);
        F_Low4=0;
      }
    }else{
      F_Low4=!F_Low4;
      if (!F_Low4){
        RXByte(RX_CHAR);
      }
    }
  }
}

//------------------------------------------------------
void TX_NEW(unsigned char NDev, unsigned char Cmd){//    LIN
//------------------------------------------------------
	PIE1bits.TX1IE=0;
	IOBuff.Size=0;
	IOBuff.Head1=0xC0;
	IOBuff.Head2=0x03;
	IOBuff.NDev=NDev;
	IOBuff.CS=NDev;
	IOBuff.Cmd=Cmd;
	IOBuff.CS ^= Cmd;
}

//------------------------------------------------------
void TX_ADD(unsigned char AddChar){//     
//------------------------------------------------------
	IOBuff.Data[IOBuff.Size]=AddChar; 
	IOBuff.CS ^= AddChar;
	IOBuff.Size++;
	if (IOBuff.Size>66) IOBuff.Size--;
}

//------------------------------------------------------
void TX_START(void){//  ,  
//------------------------------------------------------
  BYTE i;
  IOBuff.CS ^= IOBuff.Size;
	IOBuff.Data[IOBuff.Size]=IOBuff.CS;
	IOBuff.Data[IOBuff.Size+1]=0x55;
	IOBuff.Count=0;
	PIE1bits.TX1IE=1;

  TRISC=0x00;
  for (i=0;i<(IOBuff.Size+7);i++){
    while(P_FTTXE);
    P_FTWR=1;
    LATC=(LATC & 0xF0)| ((IOBuff.mas[i]>>4)&0x0F);
    Nop();
    P_FTWR=0;
    Nop();
    while(P_FTTXE);
    P_FTWR=1;
    LATC=(LATC & 0xF0)|((IOBuff.mas[i])&0x0F);
    Nop();
    P_FTWR=0;
    Nop();
  }
  TRISC=0x0F;
}

//------------------------------------------------------
void SendState(void){//  
//------------------------------------------------------
	TX_NEW(IOBuff.NDev, IOBuff.Cmd);
	TX_ADD(St0>>8);
	TX_ADD(St0);
	TX_ADD(St1>>8);
	TX_ADD(St1);
	TX_ADD(St2>>8);
	TX_ADD(St2);
	TX_START();
}

//------------------------------------------------------
void CheckCmd(void){//  
//------------------------------------------------------
  if (!F_NEW_CMD) return;
  F_NEW_CMD=0;
  TIOIdle=0;
  //  ,  
	if ((IOBuff.NDev==0)&&(IOBuff.Cmd==0)){
		reset();
	}
  if (IOBuff.NDev==cNDEV){
  }else return;
  //  
	switch (IOBuff.Cmd){
    case 0x00:{// 
      if (IOBuff.Size!=0)return;
      TX_NEW(IOBuff.NDev, IOBuff.Cmd);
      TX_START();
			reset();
      break;
    }
		case 0x01:{//   ID
      if (IOBuff.Size!=0)return;
      TX_NEW(IOBuff.NDev, IOBuff.Cmd);
			TX_ADD(VER_HARD);
			TX_ADD(DEV_ID);
      TX_START();
			break;
    }
		case 0x02:{// 
      if (IOBuff.Size!=0)return;
			SendState();
			break;
    }
		case 0x03:{// 
      if (IOBuff.Size!=4)return;
      StStab0=((WORD)IOBuff.Data[0]<<8)|IOBuff.Data[1];
      StStab1=((WORD)IOBuff.Data[2]<<8)|IOBuff.Data[3];
			SendState();
			break;
    }
		case 0x04:{//04 -     
      if (IOBuff.Size!=0)return;
      if (!F_AVTOMODE){
        DisInts();
        StStab0=0;
        StStab1=0;
//        cSHIM=STEPS_SHIM-1;
//        vSHIM=0;
//        eSHIM=0;
        EnaInts();
      }
      F_AVTOMODE=1;
      F_GLASMODE=0;
			SendState();
			break;
    }
		case 0x05:{//05 -    ( )
      if (IOBuff.Size!=0)return;
      F_AVTOMODE=0;
      F_GLASMODE=1;
			SendState();
			break;
    }
		case 0x06:{//06 -   ()
      if (IOBuff.Size!=2)return;
      OffAirTermo=((WORD)IOBuff.Data[0]<<8)|IOBuff.Data[1];
      F_AVTOMODE=0;
      F_GLASMODE=0;
			SendState();
			break;
    }
  }
}



