#ifndef MAIN_H
#define	MAIN_H
#include	<GenericTypeDefs.h>
#include	<xc.h>
#include	<math.h>
//#define __EXTENSION

//  ( )
#define _XTAL_FREQ 32000000L //MHz

//----------------------------------------------------------------------------------------
//	  
//----------------------------------------------------------------------------------------
#define P_S0      PORTAbits.RA0	//A,     
#define	P_S1      PORTAbits.RA1	//A,     1
#define	P_S2      PORTAbits.RA2	//A,     2
#define	P_RA3     PORTAbits.RA3	//O,
#define	P_FTTXE   PORTAbits.RA4	//I,  
#define	P_FTRXF   PORTAbits.RA5	//I,  
#define	P_FTRD    LATAbits.LA6	//O,  
#define	P_FTWR    LATAbits.LA7	//O,  

#define	P_RB0     LATBbits.LB0	//O
#define	P_RB1     LATBbits.LB1	//O
#define	P_RB2     LATBbits.LB2	//O
#define	P_RB3     LATBbits.LB3	//O
#define	P_RB4     LATBbits.LB4	//O
#define	P_RB5     LATBbits.LB5	//O
#define	P_PGC     LATBbits.LB6	//O, PGC
#define	P_PGD     LATBbits.LB7	//O, PGD

#define	P_D0      PORTCbits.RC0	//IO,
#define	P_D1      PORTCbits.RC1	//IO,
#define	P_D2      PORTCbits.RC2	//IO,
#define	P_D3      PORTCbits.RC3	//IO,
#define	P_RC4     LATCbits.LC4	//O,
#define	P_RC5     LATCbits.LC5	//O,
#define	P_ONOFF   LATCbits.LC6	//O, 0-/1- 
#define	P_TCON    LATCbits.LC7	//O, 1- 

//------------------------------------------
// 
//------------------------------------------
#define	EnaInts()	{INTCONbits.GIEH=1;}
#define	DisInts()	{INTCONbits.GIEH=0;}
#define	testbit(var, bit)	((var) & (1 <<(bit)))
#define	setbit(var, bit)	((var) |= (1 << (bit)))
#define	clrbit(var, bit)	((var) &= ~(1 << (bit)))
#define	nop()	asm("nop")
#define	reset()	asm("reset")


void HardInit(void);

//------------------------------------------
// 
//------------------------------------------
#define	cMAX_IO_BUFF	74 // -    /

//
#define	VER_HARD	0x31
#define	DEV_ID 0x00
//
#define	cNDEV	0x10

#define	cSEC_IOIDLE	0x05

//------------------------------------------
//  
//------------------------------------------
typedef volatile union { //
    unsigned char mas[cMAX_IO_BUFF];
    struct {
        unsigned char Head1;
        unsigned char Head2;
        unsigned char NDev;
        unsigned char Size;
        unsigned char Cmd;
        unsigned char Data[64];
        unsigned char CS;
        unsigned char End;
        unsigned char Count; //  / 
    };
} TIOBuff;

typedef union
{
    BYTE Val;
    struct __PACKED
    {
        BYTE E_TERMO:1;

    } bits;
} TDEV_STATE;



//------------------------------------------
// 
//------------------------------------------
// 
BYTE ADCh=0; //  
BYTE ADCount=0; // 
WORD RSt0=0;// 
WORD RSt1=0;// 
WORD RSt2=0;// 

WORD St0=0;// ( )
WORD St1=0;// (  )
WORD St2=0;// ()

WORD StStab0=0;//  ( )
WORD StStab1=0;//  (  )
WORD OffAirTermo=1000;//     


BYTE TIOIdle=0;

//  
//#define STEPS_SHIM 2 //- ()   100 
//BYTE cSHIM=STEPS_SHIM-1; //  
//signed char vSHIM=0; // 
//signed char eSHIM=0; // 


TDEV_STATE State=0; // 

BYTE DelayAD=0; //    /   

//
near BIT F_NEW_SEC = 0;
near BIT F_NEW_CMD = 0;
near BIT F_NEW_AD = 0;
near BIT F_NEW_30MS = 0;
near BIT F_AVTOMODE = 0;
near BIT F_GLASMODE = 0; // 
near BIT F_HOT = 0; //   


#endif	/* HARD_H */
